WinterhatFlash = LibStub("AceAddon-3.0"):NewAddon("WinterhatFlash", "AceConsole-3.0", "AceEvent-3.0", "AceTimer-3.0")

function WinterhatFlash:OnInitialize()
 local defaults = {
  profile = {
   time = 1,
  },
 }

 self.db = LibStub("AceDB-3.0"):New("WinterhatFlash", defaults, true)
 
 self:RegisterChatCommand("whf", "HandleChat");
 
 self.timer = nil
 
 self.helmSlot = GetInventorySlotInfo("HeadSlot");
end

function WinterhatFlash:ToggleTimer()
 if (self.timer) then
  self:CancelTimer(self.timer);
  self.timer = nil
  self:Print("Turning Off")
  return
 end
 
 if (InCombatLockdown()) then return end
 
 self.timer = self:ScheduleRepeatingTimer("ToggleHat", self.db.profile.time)
 self:Print("Turning On")
end

function WinterhatFlash:ToggleHat()
 if (InCombatLockdown()) then
  self:ToggleTimer()
  return
 end
 
 local currentHat = GetInventoryItemID("player", self.helmSlot)
  
 if (currentHat ~= 21525) then
  EquipItemByName("Green Winter Hat")
 else
  EquipItemByName("Red Winter Hat")
 end
end

function WinterhatFlash:HandleChat(input)
 if (not input) then return end
 
 local command, nextposition = self:GetArgs(input, 1, 1)
 
 if (command == "toggle") then
  self:ToggleTimer()
 end
 
 if (command == "speed") then
 local speed = self:GetArgs(input, 1, nextposition)
 speed = tonumber(speed)
  if (speed == nil or speed < 0.1 or speed > 300) then
   speed = 2
  end
  self.db.profile.time = speed
  self:Print("Speed set to: ", self.db.profile.time)
 end
end